'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _status = require('./constants/status');

var _status2 = _interopRequireDefault(_status);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var debug = require('debug')('react-file-uploader:UploadHandler');

var UploadHandler = function (_Component) {
  _inherits(UploadHandler, _Component);

  function UploadHandler() {
    _classCallCheck(this, UploadHandler);

    return _possibleConstructorReturn(this, (UploadHandler.__proto__ || Object.getPrototypeOf(UploadHandler)).apply(this, arguments));
  }

  _createClass(UploadHandler, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          file = _props.file,
          upload = _props.upload,
          autoStart = _props.autoStart;


      (0, _invariant2.default)(typeof upload === 'function', '`props.upload` must be a function');

      (0, _invariant2.default)(!!file, '`props.file` must be provided');

      if (file.status === _status2.default.PENDING && autoStart) {
        debug('autoStart in on, calling upload()');
        upload(file);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          abort = _props2.abort,
          component = _props2.component,
          customClass = _props2.customClass,
          style = _props2.style,
          upload = _props2.upload;


      return _react2.default.createElement(component, { className: (0, _classnames2.default)(customClass), style: style }, typeof this.props.children === 'function' ? this.props.children({ upload: upload, abort: abort }, this) : this.props.children);
    }
  }]);

  return UploadHandler;
}(_react.Component);

UploadHandler.propTypes = {
  abort: _propTypes2.default.func.isRequired,
  autoStart: _propTypes2.default.bool,
  children: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.arrayOf(_propTypes2.default.element), _propTypes2.default.func]),
  component: _propTypes2.default.string.isRequired,
  customClass: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.arrayOf(_propTypes2.default.string)]),
  file: _propTypes2.default.object.isRequired,
  style: _propTypes2.default.object,
  upload: _propTypes2.default.func.isRequired
};

UploadHandler.defaultProps = {
  component: 'li'
};

exports.default = UploadHandler;